##// END OF EJS Templates
cross-compiler update
Unknown -
r270:ba1e454d05b7
parent child
Show More
@@ -1,754 +1,760
1 1 #!/bin/sh
2 2
3 3 ########################################################################
4 4 # rpi23-gen-image.sh 2015-2017
5 5 #
6 6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 7 #
8 8 # This program is free software; you can redistribute it and/or
9 9 # modify it under the terms of the GNU General Public License
10 10 # as published by the Free Software Foundation; either version 2
11 11 # of the License, or (at your option) any later version.
12 12 #
13 13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 14 #
15 15 # Big thanks for patches and enhancements by 20+ github contributors!
16 16 ########################################################################
17 17
18 18 # Are we running as root?
19 19 if [ "$(id -u)" -ne "0" ] ; then
20 20 echo "error: this script must be executed with root privileges!"
21 21 exit 1
22 22 fi
23 23
24 24 # Check if ./functions.sh script exists
25 25 if [ ! -r "./functions.sh" ] ; then
26 26 echo "error: './functions.sh' required script not found!"
27 27 exit 1
28 28 fi
29 29
30 30 # Load utility functions
31 31 . ./functions.sh
32 32
33 33 # Load parameters from configuration template file
34 34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 35 use_template
36 36 fi
37 37
38 38 # Introduce settings
39 39 set -e
40 40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 41 set -x
42 42
43 43 # Raspberry Pi model configuration
44 44 RPI_MODEL=${RPI_MODEL:=2}
45 45
46 46 #bcm2708-rpi-0-w.dtb (Used for Pi 0 and PI 0W)
47 47 RPI0_DTB_FILE=${RPI0_DTB_FILE:=bcm2708-rpi-0-w.dtb}
48 48 RPI0_UBOOT_CONFIG=${RPI0_UBOOT_CONFIG:=rpi_defconfig}
49 49
50 50 #bcm2708-rpi-b.dtb (Used for Pi 1 model A and B)
51 51 RPI1_DTB_FILE=${RPI1_DTB_FILE:=bcm2708-rpi-b.dtb}
52 52 RPI1_UBOOT_CONFIG=${RPI1_UBOOT_CONFIG:=rpi_defconfig}
53 53
54 54 #bcm2708-rpi-b-plus.dtb (Used for Pi 1 model B+ and A+)
55 55 RPI1P_DTB_FILE=${RPI1P_DTB_FILE:=bcm2708-rpi-b-plus.dtb}
56 56 RPI1P_UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG:=rpi_defconfig}
57 57
58 58 #bcm2709-rpi-2-b.dtb (Used for Pi 2 model B)
59 59 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
60 60 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
61 61
62 62 #bcm2710-rpi-3-b.dtb (Used for Pi 3 model B)
63 63 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
64 64 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
65 65
66 66 #bcm2710-rpi-3-b-plus.dtb (Used for Pi 3 model B+)
67 67 RPI3P_DTB_FILE=${RPI3P_DTB_FILE:=bcm2710-rpi-3-b-plus.dtb}
68 68 RPI3P_UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG:=rpi_3_32b_defconfig}
69 69
70 70 # Debian release
71 71 RELEASE=${RELEASE:=jessie}
72 72 KERNEL_ARCH=${KERNEL_ARCH:=arm}
73 73 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
74 74 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
75 75 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
76 76 if [ "$KERNEL_ARCH" = "arm64" ] ; then
77 77 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
78 78 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
79 79 fi
80 80
81 81 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
82 82 #RASPBERRY PI 1, PI ZERO, PI ZERO W, AND COMPUTE MODULE DEFAULT Kernel BUILD CONFIGURATION
83 83 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
84 84 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
85 85 else
86 86 #RASPBERRY PI 2, PI 3, PI 3+, AND COMPUTE MODULE 3 DEFAULT Kernel BUILD CONFIGURATION
87 87 #https://www.raspberrypi.org/documentation/linux/kernel/building.md
88 88 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
89 89 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
90 90 fi
91 91
92 92 if [ "$RELEASE_ARCH" = "arm64" ] ; then
93 93 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
94 94 else
95 95 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
96 96 fi
97 97 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
98 98
99 99 # URLs
100 100 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
101 101 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
102 102 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
103 103 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
104 104 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
105 105 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
106 106
107 107 # Build directories
108 108 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
109 109 BUILDDIR="${BASEDIR}/build"
110 110
111 111 # Prepare date string for default image file name
112 112 DATE="$(date +%Y-%m-%d)"
113 113 if [ -z "$KERNEL_BRANCH" ] ; then
114 114 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
115 115 else
116 116 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
117 117 fi
118 118
119 119 # Chroot directories
120 120 R="${BUILDDIR}/chroot"
121 121 ETC_DIR="${R}/etc"
122 122 LIB_DIR="${R}/lib"
123 123 BOOT_DIR="${R}/boot/firmware"
124 124 KERNEL_DIR="${R}/usr/src/linux"
125 125 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
126 126
127 127 # Firmware directory: Blank if download from github
128 128 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
129 129
130 130 # General settings
131 131 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
132 132 PASSWORD=${PASSWORD:=raspberry}
133 133 USER_PASSWORD=${USER_PASSWORD:=raspberry}
134 134 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
135 135 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
136 136 EXPANDROOT=${EXPANDROOT:=true}
137 137
138 138 # Keyboard settings
139 139 XKB_MODEL=${XKB_MODEL:=""}
140 140 XKB_LAYOUT=${XKB_LAYOUT:=""}
141 141 XKB_VARIANT=${XKB_VARIANT:=""}
142 142 XKB_OPTIONS=${XKB_OPTIONS:=""}
143 143
144 144 # Network settings (DHCP)
145 145 ENABLE_DHCP=${ENABLE_DHCP:=true}
146 146
147 147 # Network settings (static)
148 148 NET_ADDRESS=${NET_ADDRESS:=""}
149 149 NET_GATEWAY=${NET_GATEWAY:=""}
150 150 NET_DNS_1=${NET_DNS_1:=""}
151 151 NET_DNS_2=${NET_DNS_2:=""}
152 152 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
153 153 NET_NTP_1=${NET_NTP_1:=""}
154 154 NET_NTP_2=${NET_NTP_2:=""}
155 155
156 156 # APT settings
157 157 APT_PROXY=${APT_PROXY:=""}
158 158 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
159 159
160 160 # Feature settings
161 161 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
162 162 ENABLE_I2C=${ENABLE_I2C:=false}
163 163 ENABLE_SPI=${ENABLE_SPI:=false}
164 164 ENABLE_IPV6=${ENABLE_IPV6:=true}
165 165 ENABLE_SSHD=${ENABLE_SSHD:=true}
166 166 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
167 167 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
168 168 ENABLE_SOUND=${ENABLE_SOUND:=true}
169 169 ENABLE_DBUS=${ENABLE_DBUS:=true}
170 170 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
171 171 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
172 172 ENABLE_XORG=${ENABLE_XORG:=false}
173 173 ENABLE_WM=${ENABLE_WM:=""}
174 174 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
175 175 ENABLE_USER=${ENABLE_USER:=true}
176 176 USER_NAME=${USER_NAME:="pi"}
177 177 ENABLE_ROOT=${ENABLE_ROOT:=false}
178 178 ENABLE_QEMU=${ENABLE_QEMU:=false}
179 179
180 180 # SSH settings
181 181 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
182 182 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
183 183 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
184 184 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
185 185 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
186 186
187 187 # Advanced settings
188 188 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
189 189 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
190 190 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
191 191 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
192 192 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
193 193 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
194 194 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
195 195 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
196 196 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
197 197 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
198 198 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
199 199 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
200 200
201 201 # Kernel compilation settings
202 202 BUILD_KERNEL=${BUILD_KERNEL:=false}
203 203 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
204 204 KERNEL_THREADS=${KERNEL_THREADS:=1}
205 205 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
206 206 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
207 207 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
208 208 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
209 209 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
210 210
211 211 if [ "$KERNEL_ARCH" = "arm64" ] ; then
212 212 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
213 213 else
214 214 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
215 215 fi
216 216
217 217 # Kernel compilation from source directory settings
218 218 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
219 219 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
220 220 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
221 221 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
222 222
223 223 # Reduce disk usage settings
224 224 REDUCE_APT=${REDUCE_APT:=true}
225 225 REDUCE_DOC=${REDUCE_DOC:=true}
226 226 REDUCE_MAN=${REDUCE_MAN:=true}
227 227 REDUCE_VIM=${REDUCE_VIM:=false}
228 228 REDUCE_BASH=${REDUCE_BASH:=false}
229 229 REDUCE_HWDB=${REDUCE_HWDB:=true}
230 230 REDUCE_SSHD=${REDUCE_SSHD:=true}
231 231 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
232 232
233 233 # Encrypted filesystem settings
234 234 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
235 235 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
236 236 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
237 237 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
238 238 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
239 239
240 240 # Chroot scripts directory
241 241 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
242 242
243 243 # Packages required in the chroot build environment
244 244 APT_INCLUDES=${APT_INCLUDES:=""}
245 245 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
246 246
247 247 # Packages required for bootstrapping
248 248 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
249 249 MISSING_PACKAGES=""
250 250
251 251 # Packages installed for c/c++ build environment in chroot (keep empty)
252 252 COMPILER_PACKAGES=""
253 253
254 254 set +x
255 255
256 256 # Set Raspberry Pi model specific configuration
257 257 if [ "$RPI_MODEL" = 0 ] ; then
258 258 DTB_FILE=${RPI2_DTB_FILE}
259 259 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
260 260 elif [ "$RPI_MODEL" = 1 ] ; then
261 261 DTB_FILE=${RPI2_DTB_FILE}
262 262 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
263 263 elif [ "$RPI_MODEL" = 1P ] ; then
264 264 DTB_FILE=${RPI2_DTB_FILE}
265 265 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
266 266 elif [ "$RPI_MODEL" = 2 ] ; then
267 267 DTB_FILE=${RPI2_DTB_FILE}
268 268 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
269 269 elif [ "$RPI_MODEL" = 3 ] ; then
270 270 DTB_FILE=${RPI3_DTB_FILE}
271 271 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
272 272 BUILD_KERNEL=true
273 273 elif [ "$RPI_MODEL" = 3P ] ; then
274 274 DTB_FILE=${RPI3P_DTB_FILE}
275 275 UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG}
276 276 BUILD_KERNEL=true
277 277 else
278 278 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
279 279 exit 1
280 280 fi
281 281
282 282 # Check if the internal wireless interface is supported by the RPi model
283 283 if [ "$ENABLE_WIRELESS" = true ] && [ "$RPI_MODEL" = 2 ]; then
284 284 echo "error: The selected Raspberry Pi model has no internal wireless interface"
285 285 exit 1
286 286 fi
287 287
288 288 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
289 289 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
290 290 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
291 291 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
292 292 exit 1
293 293 fi
294 294 fi
295 295
296 296 # Build RPi2/3 Linux kernel if required by Debian release
297 297 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
298 298 BUILD_KERNEL=true
299 299 fi
300 300
301 301 # Add packages required for kernel cross compilation
302 302 if [ "$BUILD_KERNEL" = true ] ; then
303 303 if [ "$KERNEL_ARCH" = "arm" ] ; then
304 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
305 else
306 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
304 if [ "$RELEASE_ARCH" = "armel" ]; then
305 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
306 fi
307 if [ "$RELEASE_ARCH" = "armhf" ]; then
308 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
309 fi
310 if [ "$RELEASE_ARCH" = "arm64" ]; then
311 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
312 fi
307 313 fi
308 314 fi
309 315
310 316 # Add libncurses5 to enable kernel menuconfig
311 317 if [ "$KERNEL_MENUCONFIG" = true ] ; then
312 318 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
313 319 fi
314 320
315 321 # Add ccache compiler cache for (faster) kernel cross (re)compilation
316 322 if [ "$KERNEL_CCACHE" = true ] ; then
317 323 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
318 324 fi
319 325
320 326 # Add cryptsetup package to enable filesystem encryption
321 327 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
322 328 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
323 329 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
324 330
325 331 if [ -z "$CRYPTFS_PASSWORD" ] ; then
326 332 echo "error: no password defined (CRYPTFS_PASSWORD)!"
327 333 exit 1
328 334 fi
329 335 ENABLE_INITRAMFS=true
330 336 fi
331 337
332 338 # Add initramfs generation tools
333 339 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
334 340 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
335 341 fi
336 342
337 343 # Add device-tree-compiler required for building the U-Boot bootloader
338 344 if [ "$ENABLE_UBOOT" = true ] ; then
339 345 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler"
340 346 fi
341 347
342 348 # Check if root SSH (v2) public key file exists
343 349 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
344 350 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
345 351 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
346 352 exit 1
347 353 fi
348 354 fi
349 355
350 356 # Check if $USER_NAME SSH (v2) public key file exists
351 357 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
352 358 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
353 359 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
354 360 exit 1
355 361 fi
356 362 fi
357 363
358 364 # Check if all required packages are installed on the build system
359 365 for package in $REQUIRED_PACKAGES ; do
360 366 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
361 367 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
362 368 fi
363 369 done
364 370
365 371 # If there are missing packages ask confirmation for install, or exit
366 372 if [ -n "$MISSING_PACKAGES" ] ; then
367 373 echo "the following packages needed by this script are not installed:"
368 374 echo "$MISSING_PACKAGES"
369 375
370 376 echo -n "\ndo you want to install the missing packages right now? [y/n] "
371 377 read confirm
372 378 [ "$confirm" != "y" ] && exit 1
373 379
374 380 # Make sure all missing required packages are installed
375 381 apt-get -qq -y install ${MISSING_PACKAGES}
376 382 fi
377 383
378 384 # Check if ./bootstrap.d directory exists
379 385 if [ ! -d "./bootstrap.d/" ] ; then
380 386 echo "error: './bootstrap.d' required directory not found!"
381 387 exit 1
382 388 fi
383 389
384 390 # Check if ./files directory exists
385 391 if [ ! -d "./files/" ] ; then
386 392 echo "error: './files' required directory not found!"
387 393 exit 1
388 394 fi
389 395
390 396 # Check if specified KERNELSRC_DIR directory exists
391 397 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
392 398 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
393 399 exit 1
394 400 fi
395 401
396 402 # Check if specified UBOOTSRC_DIR directory exists
397 403 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
398 404 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
399 405 exit 1
400 406 fi
401 407
402 408 # Check if specified FBTURBOSRC_DIR directory exists
403 409 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
404 410 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
405 411 exit 1
406 412 fi
407 413
408 414 # Check if specified CHROOT_SCRIPTS directory exists
409 415 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
410 416 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
411 417 exit 1
412 418 fi
413 419
414 420 # Check if specified device mapping already exists (will be used by cryptsetup)
415 421 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
416 422 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
417 423 exit 1
418 424 fi
419 425
420 426 # Don't clobber an old build
421 427 if [ -e "$BUILDDIR" ] ; then
422 428 echo "error: directory ${BUILDDIR} already exists, not proceeding"
423 429 exit 1
424 430 fi
425 431
426 432 # Setup chroot directory
427 433 mkdir -p "${R}"
428 434
429 435 # Check if build directory has enough of free disk space >512MB
430 436 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
431 437 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
432 438 exit 1
433 439 fi
434 440
435 441 set -x
436 442
437 443 # Call "cleanup" function on various signals and errors
438 444 trap cleanup 0 1 2 3 6
439 445
440 446 # Add required packages for the minbase installation
441 447 if [ "$ENABLE_MINBASE" = true ] ; then
442 448 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
443 449 fi
444 450
445 451 # Add required locales packages
446 452 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
447 453 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
448 454 fi
449 455
450 456 # Add parted package, required to get partprobe utility
451 457 if [ "$EXPANDROOT" = true ] ; then
452 458 APT_INCLUDES="${APT_INCLUDES},parted"
453 459 fi
454 460
455 461 # Add dbus package, recommended if using systemd
456 462 if [ "$ENABLE_DBUS" = true ] ; then
457 463 APT_INCLUDES="${APT_INCLUDES},dbus"
458 464 fi
459 465
460 466 # Add iptables IPv4/IPv6 package
461 467 if [ "$ENABLE_IPTABLES" = true ] ; then
462 468 APT_INCLUDES="${APT_INCLUDES},iptables"
463 469 fi
464 470
465 471 # Add openssh server package
466 472 if [ "$ENABLE_SSHD" = true ] ; then
467 473 APT_INCLUDES="${APT_INCLUDES},openssh-server"
468 474 fi
469 475
470 476 # Add alsa-utils package
471 477 if [ "$ENABLE_SOUND" = true ] ; then
472 478 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
473 479 fi
474 480
475 481 # Add rng-tools package
476 482 if [ "$ENABLE_HWRANDOM" = true ] ; then
477 483 APT_INCLUDES="${APT_INCLUDES},rng-tools"
478 484 fi
479 485
480 486 # Add fbturbo video driver
481 487 if [ "$ENABLE_FBTURBO" = true ] ; then
482 488 # Enable xorg package dependencies
483 489 ENABLE_XORG=true
484 490 fi
485 491
486 492 # Add user defined window manager package
487 493 if [ -n "$ENABLE_WM" ] ; then
488 494 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
489 495
490 496 # Enable xorg package dependencies
491 497 ENABLE_XORG=true
492 498 fi
493 499
494 500 # Add xorg package
495 501 if [ "$ENABLE_XORG" = true ] ; then
496 502 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
497 503 fi
498 504
499 505 # Replace selected packages with smaller clones
500 506 if [ "$ENABLE_REDUCE" = true ] ; then
501 507 # Add levee package instead of vim-tiny
502 508 if [ "$REDUCE_VIM" = true ] ; then
503 509 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
504 510 fi
505 511
506 512 # Add dropbear package instead of openssh-server
507 513 if [ "$REDUCE_SSHD" = true ] ; then
508 514 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
509 515 fi
510 516 fi
511 517
512 518 if [ "$RELEASE" != "jessie" ] ; then
513 519 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
514 520 fi
515 521
516 522 # Configure kernel sources if no KERNELSRC_DIR
517 523 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
518 524 KERNELSRC_CONFIG=true
519 525 fi
520 526
521 527 # Configure reduced kernel
522 528 if [ "$KERNEL_REDUCE" = true ] ; then
523 529 KERNELSRC_CONFIG=false
524 530 fi
525 531
526 532 # Configure qemu compatible kernel
527 533 if [ "$ENABLE_QEMU" = true ] ; then
528 534 KERNEL_DEFCONFIG="vexpress_defconfig"
529 535 if [ "$KERNEL_MENUCONFIG" = false ] ; then
530 536 KERNEL_OLDDEFCONFIG=true
531 537 fi
532 538 fi
533 539
534 540 # Execute bootstrap scripts
535 541 for SCRIPT in bootstrap.d/*.sh; do
536 542 head -n 3 "$SCRIPT"
537 543 . "$SCRIPT"
538 544 done
539 545
540 546 ## Execute custom bootstrap scripts
541 547 if [ -d "custom.d" ] ; then
542 548 for SCRIPT in custom.d/*.sh; do
543 549 . "$SCRIPT"
544 550 done
545 551 fi
546 552
547 553 # Execute custom scripts inside the chroot
548 554 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
549 555 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
550 556 chroot_exec /bin/bash -x <<'EOF'
551 557 for SCRIPT in /chroot_scripts/* ; do
552 558 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
553 559 $SCRIPT
554 560 fi
555 561 done
556 562 EOF
557 563 rm -rf "${R}/chroot_scripts"
558 564 fi
559 565
560 566 # Remove c/c++ build environment from the chroot
561 567 chroot_remove_cc
562 568
563 569 # Remove apt-utils
564 570 if [ "$RELEASE" = "jessie" ] ; then
565 571 chroot_exec apt-get purge -qq -y --force-yes apt-utils
566 572 fi
567 573
568 574 # Generate required machine-id
569 575 MACHINE_ID=$(dbus-uuidgen)
570 576 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
571 577 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
572 578
573 579 # APT Cleanup
574 580 chroot_exec apt-get -y clean
575 581 chroot_exec apt-get -y autoclean
576 582 chroot_exec apt-get -y autoremove
577 583
578 584 # Unmount mounted filesystems
579 585 umount -l "${R}/proc"
580 586 umount -l "${R}/sys"
581 587
582 588 # Clean up directories
583 589 rm -rf "${R}/run/*"
584 590 rm -rf "${R}/tmp/*"
585 591
586 592 # Clean up files
587 593 rm -f "${ETC_DIR}/ssh/ssh_host_*"
588 594 rm -f "${ETC_DIR}/dropbear/dropbear_*"
589 595 rm -f "${ETC_DIR}/apt/sources.list.save"
590 596 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
591 597 rm -f "${ETC_DIR}/*-"
592 598 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
593 599 rm -f "${ETC_DIR}/resolv.conf"
594 600 rm -f "${R}/root/.bash_history"
595 601 rm -f "${R}/var/lib/urandom/random-seed"
596 602 rm -f "${R}/initrd.img"
597 603 rm -f "${R}/vmlinuz"
598 604 rm -f "${R}${QEMU_BINARY}"
599 605
600 606 if [ "$ENABLE_QEMU" = true ] ; then
601 607 # Setup QEMU directory
602 608 mkdir "${BASEDIR}/qemu"
603 609
604 610 # Copy kernel image to QEMU directory
605 611 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
606 612
607 613 # Copy kernel config to QEMU directory
608 614 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
609 615
610 616 # Copy kernel dtbs to QEMU directory
611 617 for dtb in "${BOOT_DIR}/"*.dtb ; do
612 618 if [ -f "${dtb}" ] ; then
613 619 install_readonly "${dtb}" "${BASEDIR}/qemu/"
614 620 fi
615 621 done
616 622
617 623 # Copy kernel overlays to QEMU directory
618 624 if [ -d "${BOOT_DIR}/overlays" ] ; then
619 625 # Setup overlays dtbs directory
620 626 mkdir "${BASEDIR}/qemu/overlays"
621 627
622 628 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
623 629 if [ -f "${dtb}" ] ; then
624 630 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
625 631 fi
626 632 done
627 633 fi
628 634
629 635 # Copy initramfs to QEMU directory
630 636 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
631 637 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
632 638 fi
633 639 fi
634 640
635 641 # Calculate size of the chroot directory in KB
636 642 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
637 643
638 644 # Calculate the amount of needed 512 Byte sectors
639 645 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
640 646 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
641 647 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
642 648
643 649 # The root partition is EXT4
644 650 # This means more space than the actual used space of the chroot is used.
645 651 # As overhead for journaling and reserved blocks 35% are added.
646 652 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
647 653
648 654 # Calculate required image size in 512 Byte sectors
649 655 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
650 656
651 657 # Prepare image file
652 658 if [ "$ENABLE_SPLITFS" = true ] ; then
653 659 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
654 660 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
655 661 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
656 662 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
657 663
658 664 # Write firmware/boot partition tables
659 665 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
660 666 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
661 667 EOM
662 668
663 669 # Write root partition table
664 670 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
665 671 ${TABLE_SECTORS},${ROOT_SECTORS},83
666 672 EOM
667 673
668 674 # Setup temporary loop devices
669 675 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
670 676 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
671 677 else # ENABLE_SPLITFS=false
672 678 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
673 679 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
674 680
675 681 # Write partition table
676 682 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
677 683 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
678 684 ${ROOT_OFFSET},${ROOT_SECTORS},83
679 685 EOM
680 686
681 687 # Setup temporary loop devices
682 688 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
683 689 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
684 690 fi
685 691
686 692 if [ "$ENABLE_CRYPTFS" = true ] ; then
687 693 # Create dummy ext4 fs
688 694 mkfs.ext4 "$ROOT_LOOP"
689 695
690 696 # Setup password keyfile
691 697 touch .password
692 698 chmod 600 .password
693 699 echo -n ${CRYPTFS_PASSWORD} > .password
694 700
695 701 # Initialize encrypted partition
696 702 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
697 703
698 704 # Open encrypted partition and setup mapping
699 705 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
700 706
701 707 # Secure delete password keyfile
702 708 shred -zu .password
703 709
704 710 # Update temporary loop device
705 711 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
706 712
707 713 # Wipe encrypted partition (encryption cipher is used for randomness)
708 714 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
709 715 fi
710 716
711 717 # Build filesystems
712 718 mkfs.vfat "$FRMW_LOOP"
713 719 mkfs.ext4 "$ROOT_LOOP"
714 720
715 721 # Mount the temporary loop devices
716 722 mkdir -p "$BUILDDIR/mount"
717 723 mount "$ROOT_LOOP" "$BUILDDIR/mount"
718 724
719 725 mkdir -p "$BUILDDIR/mount/boot/firmware"
720 726 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
721 727
722 728 # Copy all files from the chroot to the loop device mount point directory
723 729 rsync -a "${R}/" "$BUILDDIR/mount/"
724 730
725 731 # Unmount all temporary loop devices and mount points
726 732 cleanup
727 733
728 734 # Create block map file(s) of image(s)
729 735 if [ "$ENABLE_SPLITFS" = true ] ; then
730 736 # Create block map files for "bmaptool"
731 737 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
732 738 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
733 739
734 740 # Image was successfully created
735 741 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
736 742 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
737 743 else
738 744 # Create block map file for "bmaptool"
739 745 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
740 746
741 747 # Image was successfully created
742 748 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
743 749
744 750 # Create qemu qcow2 image
745 751 if [ "$ENABLE_QEMU" = true ] ; then
746 752 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
747 753 QEMU_SIZE=16G
748 754
749 755 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
750 756 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
751 757
752 758 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
753 759 fi
754 760 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant